"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    List,
    Required,
    TypedDict,
)

from pydantic import Field, StrictStr

from .. import DevopnessBaseModel


class CloudProviderServiceRegion(DevopnessBaseModel):
    """
    CloudProviderServiceRegion

    Attributes:
        code (str): The code name of the region
        name (str): The formatted name of the region
        hint (str): Descriptive text to help users to know what data is stored in the field and optional extra information on how to enter data to the field
        zones (List[str]): List of availability zones of the cloud provider region
    """

    code: StrictStr = Field(description="The code name of the region")
    name: StrictStr = Field(description="The formatted name of the region")
    hint: StrictStr = Field(
        description="Descriptive text to help users to know what data is stored in the field and optional extra information on how to enter data to the field"
    )
    zones: List[StrictStr] = Field(
        description="List of availability zones of the cloud provider region"
    )


class CloudProviderServiceRegionPlain(TypedDict, total=False):
    """
    Plain version of CloudProviderServiceRegion.
    """

    code: Required[str]
    name: Required[str]
    hint: Required[str]
    zones: Required[List[str]]
