"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Required,
    TypedDict,
)

from pydantic import Field, StrictStr

from .. import DevopnessBaseModel


class CredentialProvider(DevopnessBaseModel):
    """
    CredentialProvider

    Attributes:
        code (str): The provider code
        name (str): The provider name
        hint (str): Descriptive text to help users to know what data is stored in the field and optional extra information on how to enter data to the field
        type (str): Type of provider.
        type_human_readable (str): Human readable version of provider type
    """

    code: StrictStr = Field(description="The provider code")
    name: StrictStr = Field(description="The provider name")
    hint: StrictStr = Field(
        description="Descriptive text to help users to know what data is stored in the field and optional extra information on how to enter data to the field"
    )
    type: StrictStr = Field(description="Type of provider.")
    type_human_readable: StrictStr = Field(
        description="Human readable version of provider type"
    )


class CredentialProviderPlain(TypedDict, total=False):
    """
    Plain version of CredentialProvider.
    """

    code: Required[str]
    name: Required[str]
    hint: Required[str]
    type: Required[str]
    type_human_readable: Required[str]
