"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    List,
    Required,
    TypedDict,
    Union,
)

from pydantic import Field

from .. import DevopnessBaseModel
from .static_network_rule_direction import (
    StaticNetworkRuleDirection,
    StaticNetworkRuleDirectionPlain,
)
from .static_network_rule_protocol import (
    StaticNetworkRuleProtocol,
    StaticNetworkRuleProtocolPlain,
)


class NetworkRuleOptions(DevopnessBaseModel):
    """
    NetworkRuleOptions

    Attributes:
        directions (List[StaticNetworkRuleDirection]): The supported network rule&#39;s traffic directions
        protocols (List[StaticNetworkRuleProtocol]): The supported network rule&#39;s protocols
    """

    directions: List[StaticNetworkRuleDirection] = Field(
        description="The supported network rule's traffic directions"
    )
    protocols: List[StaticNetworkRuleProtocol] = Field(
        description="The supported network rule's protocols"
    )


class NetworkRuleOptionsPlain(TypedDict, total=False):
    """
    Plain version of NetworkRuleOptions.
    """

    directions: Required[
        List[
            Union[
                StaticNetworkRuleDirection,
                StaticNetworkRuleDirectionPlain,
            ]
        ]
    ]
    protocols: Required[
        List[
            Union[
                StaticNetworkRuleProtocol,
                StaticNetworkRuleProtocolPlain,
            ]
        ]
    ]
