"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from datetime import datetime
from typing import (
    Optional,
    TypedDict,
    Union,
)

from pydantic import Field, StrictStr

from .. import DevopnessBaseModel
from .credits import Credits, CreditsPlain


class SubscriptionBalance(DevopnessBaseModel):
    """
    SubscriptionBalance

    Attributes:
        credits (Credits, optional):
        unit (str, optional): The unit of measurement to count credits
        billing_period_started_at (datetime, optional): The date and time the subscription plan starts
        billing_period_ends_at (datetime, optional): The date and time the subscription plan ends
        created_at (datetime, optional): The date and time when the record was created
        updated_at (datetime, optional): The date and time when the record was last updated
    """

    credits: Optional[Credits] = None
    unit: Optional[StrictStr] = Field(
        default=None, description="The unit of measurement to count credits"
    )
    billing_period_started_at: Optional[datetime] = Field(
        default=None, description="The date and time the subscription plan starts"
    )
    billing_period_ends_at: Optional[datetime] = Field(
        default=None, description="The date and time the subscription plan ends"
    )
    created_at: Optional[datetime] = Field(
        default=None, description="The date and time when the record was created"
    )
    updated_at: Optional[datetime] = Field(
        default=None, description="The date and time when the record was last updated"
    )


class SubscriptionBalancePlain(TypedDict, total=False):
    """
    Plain version of SubscriptionBalance.
    """

    credits: Optional[
        Union[
            Credits,
            CreditsPlain,
        ]
    ]
    unit: Optional[str]
    billing_period_started_at: Optional[datetime]
    billing_period_ends_at: Optional[datetime]
    created_at: Optional[datetime]
    updated_at: Optional[datetime]
